/* getdatm- to enter the freq percent for each phi class by group */

#include "sedlab.h"
#include "gstat.h"
int
getdata(plist,fplist,vflag,oflag,gflag)
double plist[],fplist[];
int vflag,oflag,gflag;
/* vflag set -> verify before accept data 
   gflag set -> data entered by group (sand,gravel,fines) each sums to 100% 
   oflag set -> data entered as cumulative freq 11.0 = 100%  */

{
	double atof(),sum;
	float sums,sumf,sumg;
	int dend,i;
	

/*  data read is freq percent from phi(11.0) to dend at 1.0 phi intervals 
	the first line is already in the 'line' buffer */

restart:
sum = sumf = sums = sumg = 0.0;
if (pfine > 0.0001)
{
fstart:
	sumf = 0.0;
	fprintf(stderr,"\n Enter %% fines:\n");
	for (i=0;i <= 6 ; i++)
		{
		fprintf(stderr,"%6.1f:  ",plist[i]);
		if  (getlin() == EOF)  return (EOF);
		if (line[0] == '.' && line[1] == '\0')  break;
		if (line[0] == 'r' && line[1] == 'e') goto fstart;
		fplist[i] = atof(line);
		if (oflag && fplist[i] == 0.0)  goto stop;
		if (oflag && fplist[0] != 100.0) 
			{
			for (i=0;i <= 6; i++)  fplist[i] = 0.0;
			fprintf (stderr,
			"Phi 11 must == 100%%\n");
			goto fstart;
			}
		sumf += fplist[i];
		}
	dend = --i;
	if (vflag && gflag)
		 if (verify(plist,fplist,0,dend) == EOF) goto fstart; 
	if (gflag) 
		{
		if (sumf > 100.1 || sumf < 99.9)
			{
			fprintf(stderr,
			"Grouped fp must sum to 100%% not '%6.2f'\n",sumf);
			goto fstart;
			}
		sumf = 0.0;
		for (i = 0; i <= dend ; i++)   
			{
			fplist[i] *= pfine;
			sumf += fplist[i];
			}
		}
	
}
if (psand > 0.0001 )
{
sstart:
	sums = 0.0;
	fprintf(stderr,"\n Enter  %% for sand\n");
	for (i=7;i <= 11 ; i++)
		{
		fprintf(stderr,"%6.1f:  ",plist[i]);
		if  (getlin() == EOF)  return(EOF);
		if (line[0] == '.' && line[1] == '\0')  break;
		if (line[0] == 'r' && line[1] == 'e') goto sstart;
		if (line[0] == 'R' && line[1] == 'E')  goto restart;
		fplist[i] = atof(line);
		if (oflag && fplist[i] == 0.0)  goto stop;
		sums += fplist[i];
		}
		
	dend = --i;
	if (vflag && gflag) 
		if (verify(plist,fplist,7,dend) == EOF)  goto sstart;
	if (gflag) 
		{
		if (sums < 99.9 || sums > 100.1)
			{
			fprintf(stderr,
			"Grouped fp must sum to 100%% not '%6.2f'\n",sums);
			goto sstart;
			}
		sums = 0.0;
		for (i = 7; i <= dend; i++)
			{
			fplist[i] *= psand;
			sums += fplist[i];
			}
		}
}
if (pgravel > 0.0001)
{
gstart:
	sumg = 0.0;
	fprintf(stderr,"\n Enter %% gravel\n");
	for (i=12;i < MAXPLIST ; i++)
		{
		fprintf(stderr,"%6.1f:  ",plist[i]);
		if  (getlin() == EOF)  return (EOF);
		if (line[0] == '.' && line[1] == '\0')  break;
		if (line[0] == 'r' && line[1] == 'e') goto gstart;
		if (line[0] == 'R' && line[1] == 'E') goto restart;
		fplist[i] = atof(line);
		if (oflag && fplist[i] == 0.0)  goto stop;
		sumg += fplist[i];
		}
	dend = --i;
	if (vflag && gflag) 
		if (verify(plist,fplist,12,dend) == EOF)  goto gstart;
	if (gflag)  
		{
		if (sumg > 100.1 || sumg < 99.9)
			{
			fprintf(stderr,
			"Grouped fp must sum to 100%% not '%6.2f'\n",sumg);
			goto gstart;
			}
		sumg = 0.0;
		for (i = 12 ; i <= dend; i++)
			{
			fplist[i] *= pgravel;
			sumg += fplist[i];
			}
		}
	
}
stop:
sum = sumf + sumg + sums;	
dend = i;
if (oflag) {
	for (i=0;i <= dend ; i++)
		if ((fplist[i] -= fplist[i+1]) < 0.0)
			{
			for (i=0;i <= MAXPLIST ; i++)  fplist[i] = 0.0;
			fprintf(stderr,
			"Cum freq %% must be in decreasing order\07\n");
			goto restart;
			}
	}
else 
   if (sum < 99.9 || sum > 100.1)
	{
	fprintf(stderr,"\07 Sum of fps [%6.1f] not between 99.9,100.1\n",sum);
	goto fstart;
	}
if (!gflag)
	if (verify(plist,fplist,0,dend) == EOF) goto restart; 
return (dend);
}
	
