/* gprint - to print out to stdout statistics & frequency distributions */

#include "sedlab.h"
#include "gstat.h"

void
gprint(fplist,cfp,dend)
double fplist[],cfp[];
int dend;
	{
	int phi,i;

	printf ("\n\n");
	prhead();
	
	printf ("Project:    %-20s", project);
	printf ("          Cruise: %-20s\n", cruise);
	printf ("Requestor:  %-20s          Operator:  %-20s\n",reqnam,oprnam);
	printf ("Analysis Date: %s\n\n", anadat);
	
	printf ("Location: %s,%s          Sampling Device: %s",
		latdd,londd,device);
	printf ("    Area: %s\n",area);
	printf ("Sample Depth (m): %s",depth);
	printf ("    Top Depth (cm): %s",dtop);
	printf ("    Bottom Depth (cm): %s\n",dbot);

	printf ("\n    Sample weight (grams): %.4f\n",sample);
	printf ("    %.2f%% gravel,   %.2f%% sand,  %.2f%% silt,",
		pgravel,psand,psilt);
	printf ("  %.2f%% clay\n\n",pclay);
	printf ("    Sample is '%s'\n\n", shepsnam);

	i = 0;
	for (phi = 11 ; phi >= -5 ; phi--)
	   {
	   if (i > dend)  break;
	    printf ("    phi(%2d): %6.2f%%     %6.2f%%\n",
			phi,fplist[i],cfp[i]);
	    i++;
	    }

	printf ("\n\n\n    ********** ");
	printf ("METHOD OF MOMENTS STATISTICS **********\n\n");
	printf ("    Median: %6.2f       ", median);
	printf ("    Mean: %6.2f\n",  mean);
	printf ("    Standard Deviation: %6.2f", stdev);
	printf ("    Skewness: %6.2f", skew);
	printf ("     Kurtosis:  %6.2f\n\n", kurt);
	
	for (i = 0 ; i < nmodes; i++)
	  printf ("     Modal class: %6.2f          Modal Frequency: %6.2f\n\n",
			mc[i],mf[i]);

	return;
	}

