/* stats - to compute the cummulative frequency distribution and method of 
		moments statistics of fplist[0-dend] and print to stdout */

#include "sedlab.h"
#include "gstat.h"
#include <math.h>

void
stats(fplist,cfp,dend)
double fplist[],cfp[];
int dend;
	{
	int i,j,d,ip,phi;
	double dphi,f[MAXPLIST],emp1,zm1,zm2,zm3,zm4;
	double med(),moments(),sqrt(),pow();
	char *name();

	for (j=0; j <= dend; j++)
		if (fplist[j] > 0.001)  break;
	cfp[dend] = fplist[dend];
	f[0] = fplist[dend];
	d = 1;
	for (i=dend-1; i >= 0; i--)
		{
		cfp[i] = cfp[i+1] + fplist[i];
		if (i >= j)
			f[d++] = fplist[i];
		}

	/* now f[] contains coarse to fine with only valid data (non-zero) */	
	ip = dend - j + 1; 	/* ip is now the number of samples */
	
	/* compute mean & median */

	dphi = 1.0;
	/* determine phi at first non-zero frequency percent */
	for (d=0,phi=11.0 ; phi >= -5 ; phi -= dphi)
		if (d++ >= dend) break;

	emp1 = phi - 0.5*dphi;

	median = med(f,ip,dphi,emp1);
	
	if (ip > 1)
		{
		mean = moments(ip, emp1,dphi,f,&zm2,&zm3,&zm4);
		stdev = sqrt(zm2);
		skew = 0.5*zm3/(stdev*zm2);
		kurt = zm4/pow(zm2,2.0) - 3.0;
		}
	else
		{
		mean = emp1;
		stdev = 0.0;
		kurt = 0.0;
		skew = 0.0;
		}
	

	/* compute mode(s)	*/
	mode(f,emp1,dphi,ip);
	

	/* determine verbal classification */
	shepsnam = name();

	return;
	}

